import os, re, pickle, json, datetime
from TQ import *
from operator import itemgetter

os.chdir('C:/Users/batagelj/work/Python/temporal/terror')

print('start:',datetime.datetime.now().ctime())
with open("terror.p","rb") as p: V = pickle.load(p)
W = V['mat']
n = len(W); All = range(n)
names = V['nam']
times = V['tim']
act   = V['act']
print('input:',datetime.datetime.now().ctime())

A = [[]]*n; S = [0]*n
for u in range(n):
   a = []
   for v in range(n):
      a = TQ.sum(a,W[v][u] if v < u else W[u][v])
   A[u] = a
print('activity:',datetime.datetime.now().ctime())

for u in range(n): S[u] = TQ.total(A[u])
print('total:',datetime.datetime.now().ctime())

P = sorted(enumerate(S),key=itemgetter(1),reverse=True)
print('sort:',datetime.datetime.now().ctime())

for i in range(100):
   print(i+1,names[P[i][0]],P[i][1])

F = [ P[i][0] for i in range(50) ]
Z = [[ W[u][v] for v in F] for u in F]
nams = [names[u] for u in F]
Z1 = [[TQ.filter(Z[u][v],lambda v: v>9) for u in range(50)] for v in range(50)]
TQ.Mat2Pajek(Z1,file="Z10big.net",names=nams,labels=True)

deg = TQ.MatVecRight(TQ.MatBin(TQ.MatSym(TQ.MatSetDiag(TQ.MatBin(W),TQ.sN))),TQ.VecConst(n))
TQ.maxmin(); delta = []
for d in deg: delta = TQ.sum(delta,d)
TQ.combinatorial()


