from TQ import *

A = [ [ [] for i in range(8)] for j in range(8)]

A[0][1] = [(1,9,1)]
A[0][2] = [(1,9,1)]
A[1][4] = [(1,9,1)]
A[1][3] = [(1,9,1)]
A[2][4] = [(1,9,1)]
A[2][3] = [(1,9,1)]
A[3][5] = [(1,9,1)]
A[3][6] = [(1,9,1)]
A[4][4] = [(1,9,1)]
A[4][5] = [(1,9,1)]
A[4][6] = [(1,9,1)]
A[5][7] = [(1,9,1)]
A[6][7] = [(1,9,1)]
A[7][1] = [(1,9,1)]
A[1][0] = [(5,9,1)]
A[3][5] = [(1,4,1), (6,9,1)]
A[6][0] = [(3,7,1)]

print("Matrix A");  TQ.MatList(A,all=False)

G = TQ.MatSetVal(A,(1,1))
print("Matrix G");  TQ.MatList(G,all=False)

TQ.geodetic(); TQ.report()

p = TQ.prod(G[0][1],G[1][4])
s = TQ.sum(G[0][1],G[1][4])
print("a*b = ",p)
print("a+b = ",s)
print("p+s = ",TQ.sum(p,s))
print("N+a = ",TQ.sum(TQ.sN,G[1][4]))
print("N*a = ",TQ.prod(TQ.sN,G[1][4]))
print("E+a = ",TQ.sum(TQ.sE,G[1][4]))
print("E*a = ",TQ.prod(TQ.sE,G[1][4]))

# C = TQ.MatClosure(G,strict=True)
# print("Matrix C");  TQ.MatList(C,all=True)

print("Matrix G");  TQ.MatList(G,all=False)

# TQ.Mat2Pajek(G,file="Geo2.net",labels=True)

b = TQ.betweenness(G)
print("Betweenness"); TQ.VecList(b)

cl = TQ.closeness(A,type=1)
print("Closeness 1"); TQ.VecList(cl)

print("Star -----------------------")

S = [ [ [] for i in range(6)] for j in range(6)]

S[0][1] = S[1][0] = [(1,9,1)]
S[0][2] = S[2][0] = [(1,9,1)]
S[0][3] = S[3][0] = [(1,9,1)]
S[0][4] = S[4][0] = [(1,9,1)]
S[0][5] = S[5][0] = [(1,9,1)]

G = TQ.MatSetVal(S,(1,1))

b = TQ.betweenness(G)
print("Betweenness"); TQ.VecList(b)

cl = TQ.closeness(S,type=1)
print("Closeness 1"); TQ.VecList(cl)

cl = TQ.closeness(S,type=2)
print("Closeness 2"); TQ.VecList(cl)

cl = TQ.closeness(S,type=3)
print("Closeness 3"); TQ.VecList(cl)
