from TQ import *

G = [ [ [] for i in range(15)] for j in range(15)]

G[1][0] = G[0][1] = [(1,9,1)]
G[2][1] = [(1,9,1)]
G[1][3] = [(3,9,1)]
G[5][3] = [(1,9,1)]
G[3][4] = [(1,9,1)]
G[4][5] = [(1,9,1)]
G[4][6] = [(1,5,1)]
G[6][7] = [(1,9,1)]
G[6][8] = [(1,9,1)]
G[6][9] = [(1,9,1)]
G[10][6] = [(7,9,1)]
G[7][8] = [(1,9,1)]
G[7][9] = [(1,9,1)]
G[10][7] = [(1,9,1)]
G[8][9] = [(1,9,1)]
G[8][10] = [(1,9,1)]
G[9][10] = [(1,9,1)]
G[12][13] = G[13][12] = [(2,8,1)]
G[14][13] = G[13][14] = [(2,8,1)]
G[12][14] = G[14][12] = [(2,8,1)]

print("Matrix G");  TQ.MatList(G,all=False)

TQ.Mat2Pajek(G,file='G2.net',labels=True)
# H = TQ.MatSym(G)
# print("Matrix H");  TQ.MatList(H,all=False)

print("indegree");  i = TQ.inDeg(G);  TQ.VecList(i)
print("outdegree"); o = TQ.outDeg(G); TQ.VecList(o)

W = TQ.weakConnMat(G); p = TQ.eqMat2Part(W)
# p = TQ.eqMat2Part(TQ.weakConnMat(G))
print("Weak partition"); TQ.VecList(p)

TQ.report()
S = TQ.strongConnMat(G)
print("Matrix S");  TQ.MatList(S,all=False)
s = TQ.eqMat2Part(S)
print("Strong partition"); TQ.VecList(s)

TQ.reach() 
R = TQ.MatClosure(TQ.MatBin(G),strict=True)
TQ.combinatorial() 
inReach  = TQ.inDeg(R)
print("Input reachability"); TQ.VecList(inReach)
outReach = TQ.outDeg(R)
print("Output reachability"); TQ.VecList(outReach)


   
