from TQ import *
import pickle
          
with open("exampleA.p","rb") as p: V = pickle.load(p)
print('keys = ',list(V.keys()))
W = V['mat']
W[5][3] = [(3,7,9), (8,10,8)]
W[2][1] = [(4,9,5)]
    
print("matrix"); TQ.MatList(W,all=False)
# test operations
TQ.combinatorial(); TQ.report()

print("W[1][2]+W[2][3] = ",TQ.sum(W[0][1],W[1][2]))
print("W[1][2]*W[2][3] = ",TQ.prod(W[0][1],W[1][2]))
      
# directed degrees

print("Binary"); B = TQ.MatBin(W); TQ.MatList(B,all=False)

print("outDegrees"); od = TQ.outDeg(W); TQ.VecList(od)
print("inDegrees"); id = TQ.inDeg(W); TQ.VecList(id)

# undirected degrees

print("Binary/Edges")
Ab = TQ.MatSetDiag(TQ.MatBin(W),TQ.sN)
print("matrix Ab"); TQ.MatList(Ab,all=False)
S = TQ.MatSym(Ab)
print("matrix S"); TQ.MatList(S,all=False)

print("Degrees"); od = TQ.outDeg(S); TQ.VecList(od)

TQ.maxmin(); TQ.report()
delta = []
for d in od: delta = TQ.sum(delta,d)
print('delta = ',delta)
TQ.combinatorial(); TQ.report()

# directed Clustering coefficient
print("matrix SA")
C = TQ.MatProd(S,Ab); TQ.MatList(C,all=False)

tri = TQ.MatProdDiag(C,S)
print("triangles"); TQ.VecList(tri)

cc = TQ.clusCoef(W)
print("Clustering coefficient"); TQ.VecList(cc)

# undirected Clustering coefficient

cc = TQ.clusCoef(S)
print("Clustering coefficient"); TQ.VecList(cc)

TQ.report()

