import os, re, pickle, json
from TQ import *
from operator import itemgetter

os.chdir('C:/Users/batagelj/work/Python/temporal/terror')

with open("terrorS.p","rb") as p: V = pickle.load(p)
W = V['mat']
n = len(W); All = range(n)
names = V['nam']
times = V['tim']
act   = V['act']

A = [[]]*n; S = [0]*n
for u in range(n):
   a = []
   for v in range(n):
      a = TQ.sum(a,W[v][u] if v < u else W[u][v])
   A[u] = a
for u in range(n): S[u] = TQ.total(A[u])
P = sorted(enumerate(S),key=itemgetter(1),reverse=True)
for i in range(100):
   print(i+1,names[P[i][0]],P[i][1])
F = [ P[i][0] for i in range(50) ]
Z = [[ W[u][v] for v in F] for u in F]
D = TQ.MatSym([[ TQ.invert(W[u][v]) for v in F] for u in F])
PF = TQ.pathFinder(D,r=TQ.inf)
nams = [names[u] for u in F]
Zpf = [[[] for v in range(50)] for u in range(50)]
for u in range(50):
   for v in range(50):
      Zpf[u][v] = TQ.extract(PF[u][v],Z[u][v])
TQ.Mat2Pajek(Zpf,file="PF50.net",names=nams,labels=True)

Z1 = [[[] for v in range(50)] for u in range(50)]
for u in range(50):
   for v in range(50):
      Z1[u][v] = TQ.filter(Z[u][v],lambda v: v>9)
TQ.Mat2Pajek(Z1,file="Z10.net",names=nams,labels=True)

comp = {}
comp['tit'] = 'Terror news - September 11th / short'
comp['num'] = len(F)
comp['nam'] = nams
comp['act'] = [A[i] for i in F]
comp['tot'] = [S[i] for i in F]
comp['tim'] = times
comp['mat'] = Z
with open('terrComp.json',mode='w',encoding='utf-8') as f:
   json.dump(comp,f,indent=2)

